<template>
  <div class="dialog-box" style="position: relative">
    <el-scrollbar class="custom-scroll content-box">
      <el-form
        ref="formEditTourVisaTypeRef"
        :model="formData"
        :size="layoutStore.defaultFormItemSize"
        :rules="rules"
        label-width="120px"
        label-position="right"
        @submit.prevent
      >
        <el-row :gutter="16">
          <el-col :span="24">
            <el-form-item label="签证类型名称" prop="TourVisaType.title">
              <el-input
                class="input-item"
                v-model="formData.TourVisaType.title"
                type="text"
                placeholder=""
                :clearable="true"
                :show-word-limit="false"
                maxlength=""
              />
            </el-form-item>
          </el-col>
          <el-col :span="24">
            <el-form-item label="签证类型介绍" class="rich-input" prop="TourVisaType.recommand">
              <rich-editor
                ref="recommand"
                class="input-item"
                v-model="formData.TourVisaType.recommand"
              />
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
    </el-scrollbar>
    <el-row class="footer-box" type="flex" justify="end" align="middle">
      <el-button :size="layoutStore.defaultFormItemSize" @click="onCancel()">取消</el-button>
      <el-button :size="layoutStore.defaultFormItemSize" type="primary" @click="onSubmitTourVisaTypeClick()">保存</el-button>
    </el-row>
  </div>
</template>

<script lang="ts">
export default {
  name: 'formEditTourVisaType',
};
</script>

<script setup lang="ts">
import { DialogProp } from '@/components/Dialog/types';
import { VxeColumn, VxeTable } from 'vxe-table';
import { ANY_OBJECT } from '@/types/generic';
import { DictData, DictionaryBase } from '@/common/staticDict/types';
import { ElMessage, ElMessageBox, UploadFile } from 'element-plus';
import { useRoute, useRouter } from 'vue-router';
import { useCommon } from '@/common/hooks/useCommon';
import { useLayoutStore, useStaticDictStore } from '@/store';
import { useDownload } from '@/common/hooks/useDownload';
import { useDropdown } from '@/common/hooks/useDropdown';
import { DropdownOptions, ListData } from '@/common/types/list';
import { useTable } from '@/common/hooks/useTable';
import { TableOptions } from '@/common/types/pagination';
import { useUpload } from '@/common/hooks/useUpload';
import { useUploadWidget } from '@/common/hooks/useUploadWidget';
import { DictionaryController } from '@/api/system';
import { treeDataTranslate, findItemFromList, findTreeNodePath, findTreeNode, stringCase } from '@/common/utils';
import { TourVisaTypeData } from '@/api/generated/tourVisaTypeController';
import { TourVisaTypeController } from '@/api/generated';

const router = useRouter();
const route = useRoute();
const layoutStore = useLayoutStore();
const { downloadFile } = useDownload();
const { getUploadHeaders, getUploadActionUrl, fileListToJson, parseUploadData, getPictureList } = useUpload();
const {
  Delete,
  Search,
  Edit,
  Plus,
  Refresh,
  Picture,
  Dialog,
  mainContextHeight,
  clientHeight,
  checkPermCodeExist,
  parseParams,
  parseArrayParams,
  formatDateByStatsType,
  getDateRangeFilter,
} = useCommon();
// 静态字典
const { staticDict: StaticDict } = useStaticDictStore();

const props = withDefaults(
  defineProps<{
    subPage?: number | string | boolean;
    id?: ANY_OBJECT;
    saveOnSubmit?: boolean;
    rowData?: ANY_OBJECT;
    // 当使用Dialog.show弹出组件时，须定义该prop属性，以便对dialog进行回调
    dialog?: DialogProp<ANY_OBJECT[]>;
  }>(),
  {
    subPage: 0,
    id: undefined,
    saveOnSubmit: true,
    rowData: undefined,
    dialog: undefined,
  },
);

const formEditTourVisaTypeRef = ref();
// 表单数据定义
type FormEditTourVisaTypeData = {
  TourVisaType: TourVisaTypeData;
};
// 表单数据
const formData = reactive<FormEditTourVisaTypeData>({
  TourVisaType: {
    // 签证类型id
    id: undefined,
    // 签证类型名称
    title: undefined,
    // 签证类型介绍
    recommand: undefined,
    // 逻辑删除 1正常 -1已删除
    deleteFlag: undefined,
    // 创建人id
    createUserId: undefined,
    // 创建时间
    createTime: undefined,
    // 更新人id
    updateUserId: undefined,
    // 更新时间
    updateTime: undefined,
  },
},
);
// 表单验证规则
const rules = reactive({
  'TourVisaType.recommand': [
    {required: true, message: '请输入签证类型介绍', trigger: 'blur'}
  ],
  'TourVisaType.title': [
    {required: true, message: '请输入签证类型名称', trigger: 'blur'}
  ],
});

const onCancel = () => {
  if (props.dialog) {
    props.dialog.cancel();
  }
};

const isEdit = computed(() => {
  return props.saveOnSubmit ? props.id != null : props.rowData != null;
});

// 初始化页面数据
const loadTourVisaTypeData = () => {
  return new Promise<void>((resolve, reject) => {
    if (!isEdit.value) {
      resolve();
      return;
    }
    if (!props.saveOnSubmit && props.rowData != null) {
      formData.TourVisaType = JSON.parse(JSON.stringify(props.rowData));
      resolve();
      return;
    }
    let params: ANY_OBJECT = {
      id: props.id
    };
    TourVisaTypeController.view(params).then(res => {
      formData.TourVisaType = { ...res.data };
      resolve();
    }).catch(e => {
      reject(e);
    });
  });
};
const recommand = ref();
const onUploadError = () => {
  ElMessage.error('文件上传失败');
};
const onUploadLimit = () => {
  ElMessage.error('已经超出最大上传个数限制');
};
const refreshFormEditTourVisaType = () => {
  // 刷新段落
};
/**
 * 重置过滤值
 */
const resetFormEditTourVisaType = () => {
  refreshFormEditTourVisaType();
};
/**
 * 重置所有过滤值
 */
const resetFilter = () => {
  resetFormEditTourVisaType();
};
/**
 * 保存
 */
const onSubmitTourVisaTypeClick = () => {
  // 更新富文本字段值
  formData.TourVisaType.recommand = recommand.value?.getHtml();
  formEditTourVisaTypeRef.value.validate((valid) => {
    if (!valid) return;
    // 级联操作
    if (!props.saveOnSubmit) {
      let retFormData = {
        ...formData.TourVisaType
      };
  props.dialog?.submit(retFormData);
      return;
    }
    let params: ANY_OBJECT = {
      tourVisaTypeDto: {
        id: formData.TourVisaType.id,
        title: formData.TourVisaType.title,
        recommand: formData.TourVisaType.recommand,
        createUserId: formData.TourVisaType.createUserId,
        createTime: formData.TourVisaType.createTime,
        updateUserId: formData.TourVisaType.updateUserId,
        updateTime: formData.TourVisaType.updateTime,
      }
    };

    let httpCall = isEdit.value ? TourVisaTypeController.update : TourVisaTypeController.add;
    httpCall(params).then(res => {
      ElMessage.success('保存成功');
      props.dialog?.submit();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
  });
};
const formInit = () => {
  loadTourVisaTypeData().then(res => {
    if (isEdit.value) refreshFormEditTourVisaType();
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};

onMounted(() => {
  formInit();
});
</script>
